//Paul Diac 70
#include <cstdio>
#include <cstdlib>
#include <string>
#define NMax 1000000
using namespace std;

int T = 10;

int N, C, B;
int v[NMax], uz[NMax];

int compDesc(const void *a, const void *b) {
	return *(int*)b - *(int*)a;
}

int main() {

	for (int t = 0; t < T; t++) {
		string fname = "barci";
//		if (T) fname += to_string(t);
		FILE *fin = fopen("barci.in", "rt");
		FILE *fout = fopen("barci.out", "wt");

		fscanf(fin, "%d %d %d", &N, &C, &B);

		for (int i = 0; i < N; i++) {
			fscanf(fin, "%d", &v[i]);
			uz[i] = 0;
		}
		qsort(v, N, sizeof(v[0]), compDesc); // TODO: test without sort
		int boats = 0;

		for (int i = 0; i < N; i++) if (!uz[i]) { // for any unbarked element
			uz[i] = 1;
			int imax;
			for (imax = 0; imax < N; imax++) {
				if (!uz[imax] && v[i] + v[imax] <= C &&
					v[i] - v[imax] <= B && v[imax] - v[i] <= B) {
					// this one is the fattest match
					break;
				}
			}
			if (imax < N) {
				uz[imax] = 1; // go together
			}
			boats++;
		}

		fprintf(fout, "%d\n", boats);

		fclose(fin);
		fclose(fout);
	}

	return 0;
}
