//Paul Diac 80
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <vector>
#include <deque>
#define LMax 16

using namespace std;
FILE *fin = fopen("expand.in", "rt");
FILE *fout = fopen("expand.out", "wt");

typedef struct state {
	string s;
	int moves;
}state;

char init;
string goal;
vector<string> mv[256];
int N;

deque<state> q;


int main() {

	char tmp[LMax];
	fscanf(fin, "%c %s %d\n", &init, tmp, &N);
	goal = tmp;
	for (int i = 0; i < N; i++) {
		char c, l[LMax];
		fscanf(fin, "%c %s\n", &c, l);
		mv[c].push_back(l);
	}

	state first;
	first.s = init;
	first.moves = 0;
	q.push_back(first);

	while (true) {
		if (q.size() == 0) {
			break; // no solution ?
		}
		state s = q.front();
		q.pop_front();

		for (int i = 0; i < s.s.length(); i++) if (mv[s.s[i]].size()) { // any position of current state that has a possible move

			string pref = s.s.substr(0, i);
			string sufi = s.s.substr(i+1);

			for (int j = 0; j < mv[s.s[i]].size(); j++) { // any possible move of that character
				state ns;
				ns.moves = s.moves+1;
				ns.s = pref + mv[s.s[i]].at(j) + sufi;

				if (ns.s == goal) {
					fprintf(fout, "%d\n", ns.moves);
					fclose(fout);
					exit(0);
				}
				if (ns.moves < LMax) {
					q.push_back(ns);
				}
			}
		}
	}

	fclose(fin);
	fclose(fout);
	return 0;
}
